<?php
namespace App\Controllers\Tarifas;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Tarifas\TarifaEnvioPrecioEntity;

use App\Models\compras\ProveedorModel;

use App\Models\Tarifas\TarifaEnvioModel;

use App\Models\Tarifas\TarifaEnvioPrecioModel;

use
DataTables\Editor,
DataTables\Editor\Field;

class Tarifasenviosprecios extends \App\Controllers\BaseResourceController
{

    protected $modelName = TarifaEnvioPrecioModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Tarifa Envio Precio';
    protected static $singularObjectNameCc = 'tarifaEnvioPrecio';
    protected static $pluralObjectName = 'Tarifa Envio Precio';
    protected static $pluralObjectNameCc = 'tarifaEnvioPrecio';

    protected static $controllerSlug = 'tarifasenviosprecios';

    protected static $viewPath = 'themes/vuexy/form/tarifas/envios/';

    protected $indexRoute = 'tarifaEnvioPrecioList';



    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('TarifasEnviosPrecios.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('TarifasEnviosPrecios.tarifaEnvioPrecio')]),
            'tarifaEnvioPrecioEntity' => new TarifaEnvioPrecioEntity(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewTarifaEnvioPrecioList', $viewData);
    }


    public function add()
    {





        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);


            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('TarifasEnviosPrecios.tarifaEnvioPrecio'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult):

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [mb_strtolower(lang('TarifasEnviosPrecios.tarifaEnvioPrecio'))]) . '.';
                $message .= anchor("admin/tarifasenviosprecios/{$id}/edit", lang('Basic.global.continueEditing') . '?');
                $message = ucfirst(str_replace("'", "\'", $message));

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaEnvioPrecioEntity'] = isset($sanitizedData) ? new TarifaEnvioPrecioEntity($sanitizedData) : new TarifaEnvioPrecioEntity();
        $this->viewData['tarifaEnvioList'] = $this->getTarifaEnvioListItems($tarifaEnvioPrecioEntity->tarifa_envio_id ?? null);
        $this->viewData['proveedorList'] = $this->getProveedorListItems($tarifaEnvioPrecioEntity->proveedor_id ?? null);
        $this->viewData['tipoEnvioList'] = $this->getTipoEnvioOptions();

        $this->viewData['formAction'] = route_to('createTarifaEnvioPrecio');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('TarifasEnviosPrecios.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {

        if ($requestedId == null):
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $tarifaEnvioPrecioEntity = $this->model->find($id);

        if ($tarifaEnvioPrecioEntity == false):
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('TarifasEnviosPrecios.tarifaEnvioPrecio')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;



        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);



            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :



                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('TarifasEnviosPrecios.tarifaEnvioPrecio'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $tarifaEnvioPrecioEntity->fill($sanitizedData);

                $thenRedirect = true;
            endif;
            if ($noException && $successfulResult):
                $id = $tarifaEnvioPrecioEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [mb_strtolower(lang('TarifasEnviosPrecios.tarifaEnvioPrecio'))]) . '.';
                $message .= anchor("admin/tarifasenviosprecios/{$id}/edit", lang('Basic.global.continueEditing') . '?');
                $message = ucfirst(str_replace("'", "\'", $message));

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaEnvioPrecioEntity'] = $tarifaEnvioPrecioEntity;
        $this->viewData['tarifaEnvioList'] = $this->getTarifaEnvioListItems($tarifaEnvioPrecioEntity->tarifa_envio_id ?? null);
        $this->viewData['proveedorList'] = $this->getProveedorListItems($tarifaEnvioPrecioEntity->proveedor_id ?? null);
        $this->viewData['tipoEnvioList'] = $this->getTipoEnvioOptions();

        $this->viewData['formAction'] = route_to('updateTarifaEnvioPrecio', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('TarifasEnviosPrecios.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable_editor()
    {
        if ($this->request->isAJAX()) {

            include(APPPATH . "ThirdParty/DatatablesEditor/DataTables.php");

            // Build our Editor instance and process the data coming from _POST
            $response = Editor::inst($db, 'tarifas_envios_precios')
                ->fields(
                    Field::inst('tipo_envio')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.tipo_envio.required')
                            )
                        ),
                    Field::inst('peso_min')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.peso_min.required')
                            )
                        )
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifasEnviosPrecios.validation.peso_min.decimal')
                            )
                        ),
                    Field::inst('peso_max')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.peso_max.required')
                            )
                        )
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifasEnviosPrecios.validation.peso_max.decimal')
                            )
                        ),
                    Field::inst('precio_min')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.precio.required')
                            )
                        )
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifasEnviosPrecios.validation.precio.decimal')
                            )
                        ),
                    Field::inst('precio_max')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.precio.required')
                            )
                        )
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifasEnviosPrecios.validation.precio.decimal')
                            )
                        ),
                    Field::inst('precio_adicional')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.precio_adicional.required')
                            )
                        )
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifasEnviosPrecios.validation.precio_adicional.decimal')
                            )
                        ),
                    Field::inst('margen')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::required',
                            array(
                                'message' => lang('TarifasEnviosPrecios.validation.precio_adicional.required')
                            )
                        )
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifasEnviosPrecios.validation.precio_adicional.decimal')
                            )
                        ),
                    Field::inst('tarifa_envio_id'),
                    Field::inst('proveedor_id'),
                    Field::inst('user_created_id'),
                    Field::inst('created_at'),
                    Field::inst('user_updated_id'),
                    Field::inst('updated_at'),
                    Field::inst('is_deleted'),
                    Field::inst('deleted_at'),

                )
                ->validator(function ($editor, $action, $data) {
                    if ($action === Editor::ACTION_CREATE || $action === Editor::ACTION_EDIT) {
                        foreach ($data['data'] as $pkey => $values) {
                            // Si no se quiere borrar...
                            if ($data['data'][$pkey]['is_deleted'] != 1) {
                                $process_data['peso_min'] = $data['data'][$pkey]['peso_min'];
                                $process_data['peso_max'] = $data['data'][$pkey]['peso_max'];
                                $process_data['proveedor_id'] = $data['data'][$pkey]['proveedor_id'];
                                $process_data['tipo_envio'] = $data['data'][$pkey]['tipo_envio'];
                                $response = $this->model->checkIntervals($process_data, $pkey, $data['data'][$pkey]['tarifa_envio_id']);
                                // No se pueden duplicar valores al crear o al editar
                                if (!empty($response)) {
                                    return $response;
                                }
                            }
                        }
                    }
                })
                ->on('preCreate', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_created_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('created_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->on('preEdit', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_updated_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('updated_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->debug(true)
                ->process($_POST)
                ->data();

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();

            $response[$csrfTokenName] = $newTokenHash;

            echo json_encode($response);

        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 1;
            $requestedOrder2 = $reqData['order']['1']['column'] ?? $requestedOrder;
            $requestedOrder3 = $reqData['order']['2']['column'] ?? $requestedOrder;
            $order = TarifaEnvioPrecioModel::SORTABLE[$requestedOrder > 0 ? $requestedOrder : 1];
            $order2 = TarifaEnvioPrecioModel::SORTABLE[$requestedOrder2 > 0 ? $requestedOrder2 : 1];
            $order3 = TarifaEnvioPrecioModel::SORTABLE[$requestedOrder3 > 0 ? $requestedOrder3 : 1];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';
            $dir2 = $reqData['order']['0']['dir'] ?? $dir;
            $dir3 = $reqData['order']['0']['dir'] ?? $dir;



            $tarifa_envio_id = $reqData['tarifa_envio_id'] ?? -1;

            $resourceData = $this->model->getResource($search, $tarifa_envio_id)
                ->orderBy($order, $dir)->orderBy($order2, $dir2)->orderBy($order3, $dir3)
                ->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search, $tarifa_envio_id)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', tarifa_envio_id', 'tarifa_envio_id', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->tarifa_envio_id = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'tarifa_envio_id'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    protected function getTarifaEnvioListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('TarifasEnvios.tarifaEnvio'))])];
        if (!empty($selId)):
            $tarifaEnvioModel = model('App\Models\Tarifas\TarifaEnvioModel');

            $selOption = $tarifaEnvioModel->where('id', $selId)->findColumn('id');
            if (!empty($selOption)):
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getProveedorListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('LgProveedores.proveedor'))])];
        if (!empty($selId)):
            $proveedorModel = model('App\Models\compras\ProveedorModel');

            $selOption = $proveedorModel->where('id', $selId)->findColumn('id');
            if (!empty($selOption)):
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getTipoEnvioOptions()
    {
        $tipoEnvioOptions = [
            '' => lang('Basic.global.pleaseSelect'),
            'cajas' => 'cajas',
            'palets' => 'palets',
        ];
        return $tipoEnvioOptions;
    }


}
